acts_as_versioned not compatible with ActiveRecord 4.2.1

2015-05-27 13:55 - taha mohammed el kahlaoui

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Rails support Estimated time: 0.00 hour

Target version: 3.0.4   

Resolution: Fixed Affected version: 3.0.3

Description

Method type_cast is now renamed to type_cast_from_database.

Related issues:

Related to Redmine - Feature #19959: use paper_trail gem instead of bundled a... Closed

Related to Redmine - Defect #24348: acts_as_versioned use old style (Rails 2.... Closed

Associated revisions

Revision 14294 - 2015-05-31 09:19 - Jean-Philippe Lang

acts_as_versioned not compatible with ActiveRecord 4.2.1 (#19957).

Revision 14306 - 2015-06-13 13:10 - Jean-Philippe Lang

Merged r14294 (#19957).

History

#1 - 2015-05-27 16:39 - Toshi MARUYAMA

https://github.com/redmine/redmine/pull/55

I noticed exceptions when plugin use acts_as_versioned because of ActiveRecord.

#2 - 2015-05-27 16:42 - Toshi MARUYAMA

It seems acts_as_versioned is dead.

https://github.com/JoelJuliano/acts_as_versioned

I think we would better use paper_trail gem instead.

https://github.com/airblade/paper_trail

#3 - 2015-05-27 16:51 - Toshi MARUYAMA

- Target version set to 3.0.4

https://patch-diff.githubusercontent.com/raw/redmine/redmine/pull/55.diff

diff --git a/lib/plugins/acts_as_versioned/lib/acts_as_versioned.rb b/lib/plugins/acts_as_versioned/lib/acts_a

s_versioned.rb

index 618cf07..224a0c7 100644

--- a/lib/plugins/acts_as_versioned/lib/acts_as_versioned.rb

+++ b/lib/plugins/acts_as_versioned/lib/acts_as_versioned.rb

@@ -447,7 +447,7 @@ def clear_altered_attributes

           def write_changed_attribute(attr_name, attr_value)

             # Convert to db type for comparison. Avoids failing Float<=>String comparisons.

-            attr_value_for_db = self.class.columns_hash[attr_name.to_s].type_cast(attr_value)

+            attr_value_for_db = self.class.columns_hash[attr_name.to_s].type_cast_from_database(attr_value)

             (self.altered_attributes ||= []) << attr_name.to_s unless self.changed?(attr_name) || self.send(a

ttr_name) == attr_value_for_db

             write_attribute(attr_name, attr_value_for_db)

           end

2025-05-17 1/2

https://github.com/redmine/redmine/pull/55
https://github.com/JoelJuliano/acts_as_versioned
https://github.com/airblade/paper_trail
https://patch-diff.githubusercontent.com/raw/redmine/redmine/pull/55.diff


#4 - 2015-05-27 16:53 - Toshi MARUYAMA

- Related to Feature #19959: use paper_trail gem instead of bundled acts_as_versioned added

#5 - 2015-05-30 10:27 - Jean-Philippe Lang

- Status changed from New to Needs feedback

Can we have a test that triggers this error in Redmine?

#6 - 2015-05-30 10:34 - Toshi MARUYAMA

Jean-Philippe Lang wrote:

Can we have a test that triggers this error in Redmine?

 I think we don't use this code, so we cannot test.

We cannot manage unused code of bundled gem, so we should use maintained gem instead (#19959).

#7 - 2015-05-31 09:20 - Jean-Philippe Lang

- Category set to Rails support

- Status changed from Needs feedback to Resolved

- Resolution set to Fixed

Patch committed.

#8 - 2015-06-13 13:10 - Jean-Philippe Lang

- Status changed from Resolved to Closed

- Assignee set to Jean-Philippe Lang

#9 - 2016-11-14 16:45 - Toshi MARUYAMA

- Related to Defect #24348: acts_as_versioned use old style (Rails 2.x) of method call for #all added
